/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hip_j_H_
#define _hip_j_H_
#define hip_j_REC_LEN 127

#include "ihipj.h" 
#include "hipoint.h" 
#include "hipjtran.h" 

struct hip_j
{ 
	INT	JH1;
	INT	JH2;
	INT	JH3;
	INT	JH4;
	INT	JH5;
	FLOAT	JH6;
	FLOAT	JH7;
	FLOAT	JH8;
	FLOAT	JH9;
	FLOAT	JH10;
	FLOAT	JH11;
	FLOAT	JH12;
	FLOAT	JH13;
	hipoint	POINTING;
	array_hipjtran	TRANSITS;
}; /* End Struct */

typedef struct hip_j hip_j ;


int print_hip_j (hip_j* entry, int decode) ;
int print_hip_j_cols (hip_j* entry, int decode) ;
int print_hip_j_header () ;
FILE* jump_hip_j (long recNum) ; 
 
int read_hip_j (FILE* fp,hip_j* entry) ; 
FILE* search_hip_j (idx_hip_j* key, hip_j* arecord) ;
#endif /* _hip_j_H_ */
