/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hip_va_1_H_
#define _hip_va_1_H_
#define hip_va_1_REC_LEN 144

#include "ihipva.h" 
#include "hp_auth.h" 
#include "hg_notes.h" 
#include "hd_notes.h" 
#include "hp_notes.h" 
#include "ihpnotes.h" 
#include "ihdnotes.h" 
#include "ihgnotes.h" 
#include "ihpauth.h" 

struct hip_va_1
{ 
	INT	P1;
	CHAR	P2[2];
	CHAR	P3[13];
	CHAR	P4[2];
	CHAR	P5[7];
	CHAR	P6[2];
	FLOAT	P7;
	CHAR	P8[2];
	FLOAT	P9;
	FLOAT	P10;
	FLOAT	P11;
	FLOAT	P12;
	FLOAT	P13;
	INT	P14;
	CHAR	P15[2];
	CHAR	P16[2];
	CHAR	P17[13];
	FLOAT	P18;
	FLOAT	P19;
	FLOAT	P20;
	FLOAT	P21;
	CHAR	P22[2];
	CHAR	P23[3];
	array_hp_auth	AUTHREF;
	array_hg_notes	HGNOTES;
	array_hd_notes	HDNOTES;
	array_hp_notes	HPNOTES;
}; /* End Struct */

typedef struct hip_va_1 hip_va_1 ;


int print_hip_va_1 (hip_va_1* entry, int decode) ;
int print_hip_va_1_cols (hip_va_1* entry, int decode) ;
int print_hip_va_1_header () ;
FILE* jump_hip_va_1 (long recNum) ; 
 
int read_hip_va_1 (FILE* fp,hip_va_1* entry) ; 
FILE* search_hip_va_1 (INT* key, hip_va_1* arecord) ;
#endif /* _hip_va_1_H_ */
