/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hip_va_2_H_
#define _hip_va_2_H_
#define hip_va_2_REC_LEN 144

#include "ihipva.h" 
#include "hp_auth.h" 
#include "hg_notes.h" 
#include "hd_notes.h" 
#include "hp_notes.h" 
#include "ihpnotes.h" 
#include "ihdnotes.h" 
#include "ihgnotes.h" 
#include "ihpauth.h" 

struct hip_va_2
{ 
	INT	U1;
	CHAR	U2[2];
	CHAR	U3[13];
	CHAR	U4[2];
	CHAR	U5[7];
	CHAR	U6[2];
	FLOAT	U7;
	CHAR	U8[2];
	FLOAT	U9;
	FLOAT	U10;
	FLOAT	U11;
	FLOAT	U12;
	CHAR	U13[10];
	CHAR	U14[2];
	CHAR	U15[2];
	CHAR	U16[2];
	CHAR	U17[13];
	FLOAT	U18;
	FLOAT	U19;
	FLOAT	U20;
	FLOAT	U21;
	CHAR	U22[2];
	CHAR	U23[3];
	array_hp_auth	AUTHREF;
	array_hg_notes	HGNOTES;
	array_hd_notes	HDNOTES;
	array_hp_notes	HPNOTES;
}; /* End Struct */

typedef struct hip_va_2 hip_va_2 ;


int print_hip_va_2 (hip_va_2* entry, int decode) ;
int print_hip_va_2_cols (hip_va_2* entry, int decode) ;
int print_hip_va_2_header () ;
FILE* jump_hip_va_2 (long recNum) ; 
 
int read_hip_va_2 (FILE* fp,hip_va_2* entry) ; 
FILE* search_hip_va_2 (INT* key, hip_va_2* arecord) ;
#endif /* _hip_va_2_H_ */
