/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hipabsc_H_
#define _hipabsc_H_
#define hipabsc_REC_LEN 71

#include "hip_rgc.h" 

struct hipabsc
{ 
	INT	IA1;
	CHAR	IA2[2];
	FLOAT	IA3;
	FLOAT	IA4;
	FLOAT	IA5;
	FLOAT	IA6;
	FLOAT	IA7;
	FLOAT	IA8;
	FLOAT	IA9;
	FLOAT	IA10;
	hip_rgc	*ORBIT;
}; /* End Struct */

typedef struct hipabsc hipabsc ;


int print_hipabsc (hipabsc* entry, int decode) ;
int print_hipabsc_cols (hipabsc* entry, int decode) ;
int print_hipabsc_header () ;
FILE* jump_hipabsc (long recNum) ; 
 
int read_hipabsc (FILE* fp,hipabsc* entry) ; 

#define array_hipabsc_size 300
struct array_hipabsc
{
   int no_entries;
   hipabsc data[array_hipabsc_size];
};
typedef struct array_hipabsc array_hipabsc; 
int read_array_hipabsc (FILE* fp,int no_entries, array_hipabsc* array);
int print_array_hipabsc (array_hipabsc* array, int decode);
int print_array_hipabsc_cols (array_hipabsc* array, int decode);

#endif /* _hipabsc_H_ */
