/*  Hipparcos ASCII CD-ROM load and search routines Release 1.1 June 1997
    William O'Mullane 
    Astrophysics Division, ESTEC, Noordwijk, The Netherlands. 
    See the readme.pdf file for more information */
#ifndef _hipdmcom_H_
#define _hipdmcom_H_
#define hipdmcom_REC_LEN 240

#include "ccdm.h" 
#include "hg_notes.h" 
#include "hd_notes.h" 
#include "hp_notes.h" 
#include "ihpnotes.h" 
#include "ihdnotes.h" 
#include "ihgnotes.h" 

struct hipdmcom
{ 
	ccdm	DC1;
	INT	DC2;
	CHAR	DC3[2];
	CHAR	DC4[2];
	CHAR	DC5[2];
	CHAR	DC6[2];
	INT	DCM1;
	INT	DCM2;
	INT	DCM3;
	INT	DCM4;
	CHAR	DCM5[5];
	INT	DCM6;
	CHAR	DC7[2];
	INT	DC8;
	FLOAT	DC9;
	FLOAT	DC10;
	FLOAT	DC11;
	FLOAT	DC12;
	FLOAT	DC13;
	FLOAT	DC14;
	FLOAT	DC15;
	FLOAT	DC16;
	FLOAT	DC17;
	FLOAT	DC18;
	FLOAT	DC19;
	FLOAT	DC20;
	FLOAT	DC21;
	FLOAT	DC22;
	FLOAT	DC23;
	FLOAT	DC24;
	CHAR	DC25[2];
	FLOAT	DC26;
	FLOAT	DC27;
	FLOAT	DC28;
	FLOAT	DC29;
	INT	DCM7;
	CHAR	DCM8[27];
	array_hg_notes	HGNOTES;
	array_hd_notes	HDNOTES;
	array_hp_notes	HPNOTES;
}; /* End Struct */

typedef struct hipdmcom hipdmcom ;


int print_hipdmcom (hipdmcom* entry, int decode) ;
int print_hipdmcom_cols (hipdmcom* entry, int decode) ;
int print_hipdmcom_header () ;
FILE* jump_hipdmcom (long recNum) ; 
 
int read_hipdmcom (FILE* fp,hipdmcom* entry) ; 

#define array_hipdmcom_size 5
struct array_hipdmcom
{
   int no_entries;
   hipdmcom data[array_hipdmcom_size];
};
typedef struct array_hipdmcom array_hipdmcom; 
int read_array_hipdmcom (FILE* fp,int no_entries, array_hipdmcom* array);
int print_array_hipdmcom (array_hipdmcom* array, int decode);
int print_array_hipdmcom_cols (array_hipdmcom* array, int decode);

#endif /* _hipdmcom_H_ */
